![rosedb_ico.png](https://i.loli.net/2021/04/28/gIL2FXZcOesPmyD.png)

[![Go Report Card](https://goreportcard.com/badge/github.com/roseduan/rosedb)&nbsp;](https://goreportcard.com/report/github.com/roseduan/rosedb)![GitHub top language](https://img.shields.io/github/languages/top/roseduan/rosedb)&nbsp;[![GitHub stars](https://img.shields.io/github/stars/roseduan/rosedb)&nbsp;](https://github.com/roseduan/rosedb/stargazers)[![codecov](https://codecov.io/gh/flower-corp/rosedb/branch/main/graph/badge.svg)](https://codecov.io/gh/flower-corp/rosedb) [![CodeFactor](https://www.codefactor.io/repository/github/flower-corp/rosedb/badge)](https://www.codefactor.io/repository/github/flower-corp/rosedb) [![Go Reference](https://pkg.go.dev/badge/github.com/roseduan/rosedb.svg)](https://pkg.go.dev/github.com/roseduan/rosedb) [![Mentioned in Awesome Go](https://awesome.re/mentioned-badge.svg)](https://github.com/avelino/awesome-go#database) [![LICENSE](https://img.shields.io/github/license/flower-corp/rosedb.svg?style=flat-square)](https://github.com/flower-corp/rosedb/blob/main/LICENSE)

[English](https://github.com/roseduan/rosedb#rosedb) | 简体中文

rosedb 是一个稳定、快速、内嵌的 NoSQL 数据库，支持多种数据结构，包含 `String`、`List`、`Hash`、`Set`、`Sorted Set`。

rosedb 类似于 `Redis`，但是可以选择将 value 存储到磁盘中。

主要特性：

* **兼容 Redis 协议**
* **支持丰富的数据结构，包含 `String`、`List`、`Hash`、`Set`、`Sorted Set`**
* **内嵌使用，维护成本低**
* **高性能，对读写负载的应用都适合**
* **数据不局限于内存容量**

## 架构设计

![](https://github.com/flower-corp/rosedb/blob/main/resource/img/design-overview-rosedb.png)

## 快速开始

**1. 内嵌使用，请参考：**[examples](https://github.com/flower-corp/rosedb/tree/main/examples)

**2. 做为 Server 使用**

启动 rosedb server：

```shell
cd rosedb
make
./rosedb-server [-option value]
```

通过 cli 工具访问数据(这里的 cli 工具实际上就是 `redis-cli`)

> 目前 cli 工具只有 mac 系统的，可根据你的系统下载对应的 redis-cli 工具

```shell
cd rosedb/tools
./cli-mac -p 5200

127.0.0.1:5200> 
127.0.0.1:5200> set my_key RoseDB
OK
127.0.0.1:5200> get my_key
"RoseDB"
127.0.0.1:5200> 

```

## 文档

请参考 [wiki](https://github.com/flower-corp/rosedb/wiki)

## 参与贡献

感谢你的参与，完整的步骤及规范，请参考：[CONTRIBUTING](https://github.com/roseduan/rosedb/blob/main/CONTRIBUTING.md)

新手参与贡献，请参考：https://github.com/flower-corp/rosedb/issues/97

## 交流群

欢迎加我微信，拉你进 rosedb 项目交流群，和大牛一起交流学习。

| <img src="https://i.loli.net/2021/05/06/tGTH7SXg8w95slA.jpg" width="200px" align="left"/> |
| ------------------------------------------------------------ |
| 添加时请备注【Github】哦                                     |

## License

rosedb 根据 Apache 2.0 License 许可证授权，有关完整许可证文本，请参阅 [LICENSE](https://github.com/roseduan/rosedb/blob/main/LICENSE)。

